=begin
TIG (c) 2011
projecteye2ground.rb
Select raw geometry [edges] and type projecteye2ground into the Ruby Console
the vertices are projected onto the ground plane from the eye with cpoints 
and clines reproducing the distorted form...
=end
require 'sketchup.rb'

def projecteye2ground()
    model=Sketchup.active_model
    view=model.active_view
    eye=view.camera.eye
    ss=model.selection
    ents=model.active_entities
    model.start_operation("ProjectEye2Ground")
    gp=ents.add_group()
    gents=gp.entities
    face=gents.add_face([-1000.m,-1000.m,0],[-1000.m,1000.m,0],[1000.m,1000.m,0],[1000.m,-1000.m,0])
    fedges=face.edges
    verts=[]
    ss.each{|e|
      next if not e.class==Sketchup::Edge
      verts << e.vertices
    }
    verts.uniq!
    pts=[]
    verts.each{|a|
      v=a[0]
      vv=a[1]
      next if eye.z <= v.position.z
      next if eye.z <= vv.position.z
      pt=v.position
      ptt=vv.position
      pz=pt.clone
      pzz=ptt.clone
      ve=eye.vector_to(pt)
      rayt=model.raytest([pt,ve])
      pz=rayt[0] if rayt
      until not rayt or rayt[0].z==0
        pz=rayt[0] if rayt
        rayt=model.raytest([pz,ve])
        pz=rayt[0] if rayt and rayt[0].z==0
      end
      vee=eye.vector_to(ptt)
      raytt=model.raytest([ptt,vee])
      pzz=raytt[0] if raytt
      until not raytt or raytt[0].z==0
        pzz=raytt[0] if raytt
        raytt=model.raytest([pzz,vee])
        pzz=raytt[0] if raytt and raytt[0].z==0
      end
      pt.z=0
      ptt.z=0
      pz.z=0
      pzz.z=0
      gents.add_cpoint(pt)
      gents.add_cpoint(ptt)
      gents.add_cpoint(pz)
      gents.add_cpoint(pzz)
      gents.add_cline(pt,pz)
      gents.add_cline(ptt,pzz)
      gents.add_cline(pz,pzz)
      gents.add_cline(pt,ptt)
    }
    gents.erase_entities(fedges)
    gents.add_cpoint(eye) if gents[0]
    model.commit_operation
end
